package com.pogofish.jadt.ast;

import java.util.List;
import java.util.Map;
import com.pogofish.jadt.errors.SyntaxError;

/*
This file was generated based on /Users/jiry/workspace/JADT/target/checkout/jADT-core/src/main/jadt/jadt.jadt using jADT version null http://jamesiry.github.com/jADT/ . Please do not modify directly.

The source was parsed as: 

package com.pogofish.jadt.ast

import java.util.List
import java.util.Map
import com.pogofish.jadt.errors.SyntaxError

ParseResult =
    ParseResult(final Doc doc, final List<SyntaxError> errors)
Doc =
    Doc(final String srcInfo, final Pkg pkg, final List<Imprt> imports, final List<DataType> dataTypes)
Pkg =
    Pkg(final List<JavaComment> comments, final String name)
Imprt =
    Imprt(final List<JavaComment> comments, final String name)
DataType =
    DataType(final List<JavaComment> comments, final String name, final List<String> typeArguments, final List<Constructor> constructors)
Constructor =
    Constructor(final List<JavaComment> comments, final String name, final List<Arg> args)
Arg =
    Arg(final List<ArgModifier> modifiers, final Type type, final String name)
ArgModifier =
    Final
Type =
    Ref(final RefType type)
  | Primitive(final PrimitiveType type)
RefType =
    ClassType(final String baseName, final List<RefType> typeArguments)
  | ArrayType(final Type heldType)
PrimitiveType =
    BooleanType
  | ByteType
  | CharType
  | DoubleType
  | FloatType
  | IntType
  | LongType
  | ShortType
CommentedIdentifier =
    CommentedIdentifier(final List<JavaComment> comments, final String identifier)
JavaComment =
    JavaDocComment(final String start, final List<JDToken> generalSection, final List<JDTagSection> tagSections, final String end)
  | JavaBlockComment(List<List<BlockToken>> lines)
  | JavaEOLComment(final String comment)
JDTagSection =
    JDTagSection(String name, List<JDToken> tokens)
JDToken =
    JDAsterisk
  | JDEOL(String content)
  | JDTag(String name)
  | JDWord(String word)
  | JDWhiteSpace(String ws)
BlockToken =
    BlockWord(String word)
  | BlockWhiteSpace(String ws)
  | BlockEOL(String content)

*/
public abstract class BlockToken {

   private BlockToken() {
   }

   public static final  BlockToken _BlockWord(String word) { return new BlockWord(word); }
   public static final  BlockToken _BlockWhiteSpace(String ws) { return new BlockWhiteSpace(ws); }
   public static final  BlockToken _BlockEOL(String content) { return new BlockEOL(content); }

   public static interface MatchBlock<ResultType> {
      ResultType _case(BlockWord x);
      ResultType _case(BlockWhiteSpace x);
      ResultType _case(BlockEOL x);
   }

   public static abstract class MatchBlockWithDefault<ResultType> implements MatchBlock<ResultType> {
      @Override
      public ResultType _case(BlockWord x) { return _default(x); }

      @Override
      public ResultType _case(BlockWhiteSpace x) { return _default(x); }

      @Override
      public ResultType _case(BlockEOL x) { return _default(x); }

      protected abstract ResultType _default(BlockToken x);
   }

   public static interface SwitchBlock {
      void _case(BlockWord x);
      void _case(BlockWhiteSpace x);
      void _case(BlockEOL x);
   }

   public static abstract class SwitchBlockWithDefault implements SwitchBlock {
      @Override
      public void _case(BlockWord x) { _default(x); }

      @Override
      public void _case(BlockWhiteSpace x) { _default(x); }

      @Override
      public void _case(BlockEOL x) { _default(x); }

      protected abstract void _default(BlockToken x);
   }

   public static final class BlockWord extends BlockToken {
      public String word;

      public BlockWord(String word) {
         this.word = word;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((word == null) ? 0 : word.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         BlockWord other = (BlockWord)obj;
         if (word == null) {
            if (other.word != null) return false;
         } else if (!word.equals(other.word)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "BlockWord(word = " + word + ")";
      }

   }

   public static final class BlockWhiteSpace extends BlockToken {
      public String ws;

      public BlockWhiteSpace(String ws) {
         this.ws = ws;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((ws == null) ? 0 : ws.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         BlockWhiteSpace other = (BlockWhiteSpace)obj;
         if (ws == null) {
            if (other.ws != null) return false;
         } else if (!ws.equals(other.ws)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "BlockWhiteSpace(ws = " + ws + ")";
      }

   }

   public static final class BlockEOL extends BlockToken {
      public String content;

      public BlockEOL(String content) {
         this.content = content;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((content == null) ? 0 : content.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         BlockEOL other = (BlockEOL)obj;
         if (content == null) {
            if (other.content != null) return false;
         } else if (!content.equals(other.content)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "BlockEOL(content = " + content + ")";
      }

   }

   public abstract <ResultType> ResultType match(MatchBlock<ResultType> matchBlock);

   public abstract void _switch(SwitchBlock switchBlock);

}