package com.pogofish.jadt.ast;

import java.util.List;
import java.util.Map;
import com.pogofish.jadt.errors.SyntaxError;

/*
This file was generated based on /Users/jiry/workspace/JADT/target/checkout/jADT-core/src/main/jadt/jadt.jadt using jADT version null http://jamesiry.github.com/jADT/ . Please do not modify directly.

The source was parsed as: 

package com.pogofish.jadt.ast

import java.util.List
import java.util.Map
import com.pogofish.jadt.errors.SyntaxError

ParseResult =
    ParseResult(final Doc doc, final List<SyntaxError> errors)
Doc =
    Doc(final String srcInfo, final Pkg pkg, final List<Imprt> imports, final List<DataType> dataTypes)
Pkg =
    Pkg(final List<JavaComment> comments, final String name)
Imprt =
    Imprt(final List<JavaComment> comments, final String name)
DataType =
    DataType(final List<JavaComment> comments, final String name, final List<String> typeArguments, final List<Constructor> constructors)
Constructor =
    Constructor(final List<JavaComment> comments, final String name, final List<Arg> args)
Arg =
    Arg(final List<ArgModifier> modifiers, final Type type, final String name)
ArgModifier =
    Final
Type =
    Ref(final RefType type)
  | Primitive(final PrimitiveType type)
RefType =
    ClassType(final String baseName, final List<RefType> typeArguments)
  | ArrayType(final Type heldType)
PrimitiveType =
    BooleanType
  | ByteType
  | CharType
  | DoubleType
  | FloatType
  | IntType
  | LongType
  | ShortType
CommentedIdentifier =
    CommentedIdentifier(final List<JavaComment> comments, final String identifier)
JavaComment =
    JavaDocComment(final String start, final List<JDToken> generalSection, final List<JDTagSection> tagSections, final String end)
  | JavaBlockComment(List<List<BlockToken>> lines)
  | JavaEOLComment(final String comment)
JDTagSection =
    JDTagSection(String name, List<JDToken> tokens)
JDToken =
    JDAsterisk
  | JDEOL(String content)
  | JDTag(String name)
  | JDWord(String word)
  | JDWhiteSpace(String ws)
BlockToken =
    BlockWord(String word)
  | BlockWhiteSpace(String ws)
  | BlockEOL(String content)

*/
public abstract class JavaComment {

   private JavaComment() {
   }

   public static final  JavaComment _JavaDocComment(String start, List<JDToken> generalSection, List<JDTagSection> tagSections, String end) { return new JavaDocComment(start, generalSection, tagSections, end); }
   public static final  JavaComment _JavaBlockComment(List<List<BlockToken>> lines) { return new JavaBlockComment(lines); }
   public static final  JavaComment _JavaEOLComment(String comment) { return new JavaEOLComment(comment); }

   public static interface MatchBlock<ResultType> {
      ResultType _case(JavaDocComment x);
      ResultType _case(JavaBlockComment x);
      ResultType _case(JavaEOLComment x);
   }

   public static abstract class MatchBlockWithDefault<ResultType> implements MatchBlock<ResultType> {
      @Override
      public ResultType _case(JavaDocComment x) { return _default(x); }

      @Override
      public ResultType _case(JavaBlockComment x) { return _default(x); }

      @Override
      public ResultType _case(JavaEOLComment x) { return _default(x); }

      protected abstract ResultType _default(JavaComment x);
   }

   public static interface SwitchBlock {
      void _case(JavaDocComment x);
      void _case(JavaBlockComment x);
      void _case(JavaEOLComment x);
   }

   public static abstract class SwitchBlockWithDefault implements SwitchBlock {
      @Override
      public void _case(JavaDocComment x) { _default(x); }

      @Override
      public void _case(JavaBlockComment x) { _default(x); }

      @Override
      public void _case(JavaEOLComment x) { _default(x); }

      protected abstract void _default(JavaComment x);
   }

   public static final class JavaDocComment extends JavaComment {
      public final String start;
      public final List<JDToken> generalSection;
      public final List<JDTagSection> tagSections;
      public final String end;

      public JavaDocComment(String start, List<JDToken> generalSection, List<JDTagSection> tagSections, String end) {
         this.start = start;
         this.generalSection = generalSection;
         this.tagSections = tagSections;
         this.end = end;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((start == null) ? 0 : start.hashCode());
          result = prime * result + ((generalSection == null) ? 0 : generalSection.hashCode());
          result = prime * result + ((tagSections == null) ? 0 : tagSections.hashCode());
          result = prime * result + ((end == null) ? 0 : end.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         JavaDocComment other = (JavaDocComment)obj;
         if (start == null) {
            if (other.start != null) return false;
         } else if (!start.equals(other.start)) return false;
         if (generalSection == null) {
            if (other.generalSection != null) return false;
         } else if (!generalSection.equals(other.generalSection)) return false;
         if (tagSections == null) {
            if (other.tagSections != null) return false;
         } else if (!tagSections.equals(other.tagSections)) return false;
         if (end == null) {
            if (other.end != null) return false;
         } else if (!end.equals(other.end)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "JavaDocComment(start = " + start + ", generalSection = " + generalSection + ", tagSections = " + tagSections + ", end = " + end + ")";
      }

   }

   public static final class JavaBlockComment extends JavaComment {
      public List<List<BlockToken>> lines;

      public JavaBlockComment(List<List<BlockToken>> lines) {
         this.lines = lines;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((lines == null) ? 0 : lines.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         JavaBlockComment other = (JavaBlockComment)obj;
         if (lines == null) {
            if (other.lines != null) return false;
         } else if (!lines.equals(other.lines)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "JavaBlockComment(lines = " + lines + ")";
      }

   }

   public static final class JavaEOLComment extends JavaComment {
      public final String comment;

      public JavaEOLComment(String comment) {
         this.comment = comment;
      }

      @Override
      public <ResultType> ResultType match(MatchBlock<ResultType> matchBlock) { return matchBlock._case(this); }

      @Override
      public void _switch(SwitchBlock switchBlock) { switchBlock._case(this); }

      @Override
      public int hashCode() {
          final int prime = 31;
          int result = 1;
          result = prime * result + ((comment == null) ? 0 : comment.hashCode());
          return result;
      }

      @Override
      public boolean equals(Object obj) {
         if (this == obj) return true;
         if (obj == null) return false;
         if (getClass() != obj.getClass()) return false;
         JavaEOLComment other = (JavaEOLComment)obj;
         if (comment == null) {
            if (other.comment != null) return false;
         } else if (!comment.equals(other.comment)) return false;
         return true;
      }

      @Override
      public String toString() {
         return "JavaEOLComment(comment = " + comment + ")";
      }

   }

   public abstract <ResultType> ResultType match(MatchBlock<ResultType> matchBlock);

   public abstract void _switch(SwitchBlock switchBlock);

}